﻿using Microsoft.Extensions.Logging;
using NetworkResurrector.Agent.Application.Services.Abstractions;
using NetworkResurrector.Agent.Domain.Models;
using System.Diagnostics;

namespace NetworkResurrector.Agent.Application.Services.Windows
{
    internal class WindowsPowerService : IPowerService
    {
        private readonly ILogger<WindowsPowerService> _logger;
        private readonly ICliService _cliService;

        public WindowsPowerService(ILogger<WindowsPowerService> logger)
        {
            _logger=logger;
        }

        public void Shutdown(PowerOptions options)
        {

            var psi = new ProcessStartInfo("shutdown", "/s /t 0")
            {
                CreateNoWindow = true,
                UseShellExecute = false
            };

            Process.Start(psi);
        }

        public void Lock()
        {
            var (success, message) = _cliService.Execute("rundll32.exe user32.dll,LockWorkStation");
        }
    }
}
