﻿using MediatR;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using NetworkResurrector.Agent.PublishedLanguage.Commands;
using System.Threading.Tasks;

namespace NetworkResurrector.Agent.Controllers
{
    [ApiController]
    [Authorize]
    [Route("host")]
    public class HostController : ControllerBase
    {
        private readonly IMediator _mediator;

        public HostController(IMediator mediator)
        {
            _mediator = mediator;
        }

        [HttpPost("shutdown")]
        public async Task<IActionResult> Shutdown([FromBody] Shutdown shutdownMachine)
        {
            var result = await _mediator.Send(shutdownMachine);
            return Ok(result);
        }
    }
}
